alias fstatcheck {
  %i = $send(0) 
  if (%i == 0) {
    .timerfstat off
    halt
  }
  :rep
  if %i > 0 {  
    if ($send(%i).cps isnum) && ($send(%i).cps < %fserv.mincps) {
      msg = $+ [ $send(%i) ] cps below %fserv.mincps deteced. aborting transfer.
      .timer 1 1 close -s $send(%i)
    }
    if ($send(%i).cps isnum) && ($send(%i).cps > %fserv.maxcps) set %fserv.maxcps $send(%i).cps
    dec %i 1
    goto rep
  }  
}
alias bsize {
  if $1 > 1073741824 return $round($calc($1 / 1073741824),2) gb
  elseif $1 > 1048576 return $round($calc($1 / 1048576),2) mb
  elseif $1 > 1024 return $round($calc($1 / 1024),2) kb
  else return $1 b
}
alias fserv.announce {
  %i = $send(0)
  %a = 0
  :count
  if %i > 0 {
    inc %a $send(%i).cps
    dec %i 1
    goto count
  }
  %i = $count(%fserv.channels,.)
  %s = %logo fserve1.01 : type %fserv.trigger to get on. ( $+ %fserv.connects $+ / $+ %fserv.maxconnects connections. $send(0) $+ / $+ %fserv.maxsends sends $+ ) $bsize(%fserv.totalsends) sent - %fserv.served served
  if (%fserv.ratio != 0) set %s %s ratio 1: $+ %fserv.ratio
  if (%fserv.ratio != 0) && (%fserv.credit != 0) set %s %s credit $bsize(%fserv.credit)
  set %s %s - record: %fserv.maxcps cps! min. allowed: %fserv.mincps cps.
  :rep
  if %i > 0 {
    if (%a != 0) && (%a isnum) { %a = - bandwidth in use: %a cps }
    else { %a =  }
    msg $gettok(%fserv.channels,%i,46) %s (265 mp3z\976 mb) type !WS-List to get the list %a
    dec %i 1
    goto rep
  }    
  unset %i %s
}
alias fserv {
  if ($1 == $null) { %s = fserv is $group(#fserv) %fserv.channels }
  elseif ($1 == on) {
    .enable #fserv
    .timerfannounce 0 300 fserv.announce
    if (# !isin %fserv.channels) {
      %s = fserv is $group(#fserv)
      set %fserv.channels %fserv.channels $+ . $+ $chan
    }
    else { %s = fserv is already on in $chan }
  }
  elseif ($1 == off) {
    if (# isin %fserv.channels) && ($2 == $null) {
      set %fserv.channels $remtok(%fserv.channels,#,1,46)
      if (%fserv.channels == $null) goto off
      set %s fserv off in #   
    }
    elseif ($2 == all) {
      :off
      .disable #fserv
      %s = fserv is $group(#fserv)
      unset %fserv.channels
      unset %fserv.credit.*
      unset %fserv.nick*
    }
    else { %s = fserv not on in # }
  }
  elseif ($1 == stat) {
    if ($group(#fserv) == on) {
      echo 12 -at ws %fserv.connects $+ / $+ %fserv.maxconnects connections. $send(0) $+ / $+ %fserv.maxsends sends. $bsize(%fserv.totalsends) sent. %fserv.served served. %fserv.maxcps cps record. %fserv.mincps cps min.
      %i = %fserv.credit. [ $+ [ $nick ] ]
      %i = $send(0)
      %a = 1
      :rep
      if (%i > 0) && (%a <= %i) {
        set %s $send(%a).path $+ $send(%a).file
        set -u3 %fulldate $asctime($int($calc(($file(%s).size - $send(%a).sent) / $send(%a).cps)))
        %fulldate = $gettok($puttok(%fulldate,$puttok($gettok(%fulldate,4,32),$calc($gettok($gettok(%fulldate,4,32),1,58) + $calc($timezone / 3600)),1,58),4,32),4,32)
        echo 12 -at ws %a $+ : ( $+ $send(%a).status $+ ) $send(%a) has received $send(%a).pc $+ % ( $+ $bsize($send(%a).sent) $+ ) at $send(%a).cps cps - remaining: %fulldate
        inc %a 1
        goto rep
      }
      halt
    }
    else { %s = fserv is off }
  }
  else { %s = huh? }
  echo 12 -at ws %s
  unset %s
}
alias onchan {
  %i = $comchan($1,0)
  :rep
  if (%i > 0) {
    if ($comchan($1,%i) isin %fserv.channels) return $true
    dec %i 1
    goto rep
  }
  return $false
}
alias warnclose {
  .msg = $+ $1 closing idle connection in 30 seconds...
  .timer $+ $1 1 30 close -c $1
}
#fserv off
ON 1:TEXT:*:#:{
  if ($chan isin %fserv.channels) {
    if ($1- == %fserv.trigger) { 
      if (%fserv.maxconnects <= %fserv.connects) { 
        notice $nick the fserve is full. try again later. %logo 
      }
      else { dcc chat $nick }
    }
    if ($1 == !WS-list) dcc send $nick $mircdirfserv\mp3z\!wserve.txt
  }
}
alias doclose {
  dec %fserv.connects 1
  echo 12 -at ws $1 left the fserve
  unset %fserv.path. $+ $!
  unset %fserv.credit. $+ %nick
  set %fserv.nicks $remtok(%fserv.nicks,$1,1,46)
  %s = %logo $1 just left the fserve : type %fserv.trigger to get on. ( $+ %fserv.connects $+ / $+ %fserv.maxconnects connections. $send(0) $+ / $+ %fserv.maxsends sends $+ ) %fserv.maxcps cps record. %fserv.mincps cps min.
  if (%fserv.ratio != 0) set %s %s ratio 1: $+ %fserv.ratio
  if (%fserv.ratio != 0) && (%fserv.credit != 0) set %s %s credit $bsize(%fserv.credit) 
  if (%fserv.announce == on) {
    %i = $count(%fserv.channels,.)
    :rep
    if %i > 0 {
      msg $gettok(%fserv.channels,%i,46) %s
      dec %i 1
      goto rep
    }    
  }
  unset %s %i
}
ON 1:CLOSE:=:if ($nick isin %fserv.nicks) doclose $nick
ON 1:OPEN:=:{
  if ($onchan($nick) == $true) {
    .msg =$nick file server v1.01 %logo
    .msg =$nick (c) DaftHunk, 1998 - all rights reserved.
    .msg =$nick -
    .msg =$nick available commands: bye, cd, chdir, credit, dir, get, help, ls, quit, rules, stat
    .msg =$nick -
    set %fserv.nicks %fserv.nicks $+ . [ $+ [ $nick ] ]
    set %fserv.credit. [ $+ [ $nick ] ] %fserv.credit
    if (%fserv.rules != on) set %fserv.path. $+ $nick %fserv.root
    inc %fserv.connects 1
    inc %fserv.served 1
  }
}
ON 1:CHAT:rules:{
  if ($nick isin %fserv.nicks) && (%fserv.rules == on) {
    .msg =$nick you cannot change your nickname while in this fserve. 
    .msg =$nick you will get booted if you leave the channel.
    .msg =$nick i will be watching you and checking what you upload. so beware and behave.
    .msg =$nick all sends below %fserv.mincps cps will be aborted.
    .msg =$nick -
    set %fserv.path. $+ $nick %fserv.root
  }
  else { .msg =$nick rules are not on. }
}
ON 1:PART:#:{
  if ($nick isin %fserv.nicks) && ($comchan($nick,0) == 0) {
    .msg =$nick you must be on at least one channel with me to use this fserve.
    .msg =$nick -
    .timer 1 1 close -cs $nick
    doclose $nick
  }
}
ON 1:QUIT:if ($nick isin %fserv.nicks) { close -cs $nick | doclose $nick }
ON 1:NICK:{
  if ($nick isin %fserv.nicks) {
    .msg =$nick you must not change your nick while in my fserve.
    .msg =$nick -
    .timer 1 1 close -cs $nick
    doclose $nick
  }
}
ON 1:FILESENT:*.*:{
  if ($nick isin %fserv.nicks) {
    %s = %logo finished dcc send of $nopath($filename)
    inc %fserv.totalsends $file($filename).size
    %i = %fserv.credit. [ $+ [ $nick ] ]
    %i = $calc(%i - $file($filename).size)
    set %fserv.credit. $+ $nick %i
    if (%fserv.ration != 0) %s = %s - you now have $bsize(%i) credit
    .msg =$nick %s
    if (%fserv.announce == on) {
      %i = $count(%fserv.channels,.)
      :rep
      if %i > 0 {
        msg $gettok(%fserv.channels,%i,46) %logo fserve1.01 - just finished sending $nick  $+ $nopath($filename) - get on it! type: %fserv.trigger
        dec %i 1
        goto rep
      }    
    }
  }
}
ON 1:FILERCVD:*.*:{
  if ($nick isin %fserv.nicks) {
    %s = %logo thanks for upladling $nopath($filename) ( $+ $bsize($file($filename).size) $+ )
    if (%fserv.ratio != 0) {
      set %i $calc(%fserv.credit. [ $+ [ $nick ] ] + $file($filename).size * %fserv.ratio)
      set %fserv.credit. $+ $nick %i
      %i = %fserv.credit. [ $+ [ $nick ] ] 
      %s = %s you now have $bsize(%i) credit.
    }
    .msg =$nick %s
  }
  if $send(0) == 0 .timerfstat off
}
ON 1:CHAT:*:{
  if ($nick isin %fserv.nicks) {
    .timer $+ $nick off
    .timer $+ $nick 1 300 warnclose $nick
    set -u5 %fserv.temp %fserv.path. [ $+ [ $nick ] ] 
    if (%fserv.rules == on) && (%fserv.path. [ $+ [ $nick ] ] == $null) && ($1- != rules) {
      .msg =$nick you must read the rules first.
      .msg =$nick -
    }
    elseif ($1 == dir) || ($1 == ls) {
      if (\ isin $2-) || (/ isin $2-) || (.. isin $2-) { .msg =$nick i think not. | halt }
      set -u5 %fserv.filt $iif($2 == $null,*.*,$2)
      .msg =$nick 2 $+ $chr(91) $+ $upper($right(%fserv.temp,$calc($len(%fserv.temp) - $len(%fserv.root) + 1))) $+ %fserv.filt $+ $chr(93)
      %fserv.i = $finddir(%fserv.temp,%fserv.filt,0)
      :rep
      if (%fserv.i > 0) {
        if ($nofile($finddir(%fserv.temp,%fserv.filt,%fserv.i)) == %fserv.temp) .msg =$nick 03 $+ $upper($nopath($finddir(%fserv.temp,%fserv.filt,%fserv.i)))
        dec %fserv.i 1
        goto rep
      }
      %fserv.i = $findfile(%fserv.temp,%fserv.filt,0)
      :rep2
      if (%fserv.i > 0) {
        if ($nofile($findfile(%fserv.temp,%fserv.filt,%fserv.i)) == %fserv.temp) {
          %s = $nopath($findfile(%fserv.temp,%fserv.filt,%fserv.i))
          %i = $calc(50 - $len(%s))
          if (%i < 1) %i = 3
          .msg =$nick 02 $+ %s $+ $str(,%i) $+ 05 $+ $bsize($file($findfile(%fserv.temp,%fserv.filt,%fserv.i)).size))
        }
        dec %fserv.i 1
        goto rep2
        unset %fserv.i %fserv.temp %fserv.filt
      }
      .msg =$nick -
    }
    elseif ($1 == cd..) {
      goto backthing
    }
    elseif ($1 == cd) || ($1 == chdir) {
      if ($2 == $null) {
        .msg =$nick $chr(91) $+ $right(%s,$calc($len(%s) - $len(%fserv.root) + 1)) $+ $chr(93)
        halt
      }
      set %s %fserv.temp $+ $2-
      if ((\ isin $2) || (/ isin $2)) && (/ != $2) && (\ != $2) {
        .msg =$nick one directory at a time.
      }
      elseif ($exists(%s) == $true) || (/ == $2) || (\ == $2) {
        if (%s != %fserv.root) {
          if ($2 == /) || ($2 == \) { 
            set %fserv.path. $+ $nick %fserv.root 
            set %s %fserv.root 
            goto out
          }
          elseif ($2 == ..) {
            :backthing
            set %s %fserv.path. [ $+ [ $nick ] ]
            if (%s == %fserv.root) goto out
            set %i $calc($len(%s) - 1)
            :cdrep
            if ($mid(%s,%i,1) == /) || ($mid(%s,%i,1) == \) {
              set %fserv.path. $+ $nick $left(%s,%i)
              %s = $left(%s,%i)
              goto out
            }
            dec %i 1
            if %i > 0 goto cdrep
          }
          else { set %fserv.path. $+ $nick %s $+ \ }
          :out
          .msg =$nick 2 $+ $chr(91) $+ $upper($right(%s,$calc($len(%s) - $len(%fserv.root) + 1))) $+ $chr(93)
          echo 12 -t =$nick $chr(91) $+ $upper($right(%s,$calc($len(%s) - $len(%fserv.root) + 1))) $+ $chr(93)
        }
      }
      else {
        .msg =$nick no such directory.
      }
    }
    elseif ($1 == get) {
      set %s %fserv.temp $+ $2-
      if ($sends(0) > %fserv.maxsends) { .msg =$nick there are no slots left. please wait. }
      elseif ($exists(%s) == $false) { .msg =$nick no such file. }
      else {
        if (%fserv.ratio > 0) {
          if (%fserv.credit. [ $+ [ $nick ] ] >= $file(%s).size) {
            if ($send($nick) > 0) { .msg =$nick only 1 active send at a time. | halt }
            if ($send(0) >= %fserv.maxsends) { .msg =$nick all send slots are occupied. please wait. (check with "stat") | halt }
            dcc send $nick " $+ %s $+ "
            .timerfstat 0 5 fstatcheck
          }
          else {
            set %i %fserv.credit. [ $+ [ $nick ] ]
            .msg =$nick the file is $file(%s).size - you only have $bsize(%i) credit.
            unset %i
          }
        }
        else {
          if ($send($nick) > 0) { .msg =$nick only 1 active send at a time. | halt }
          dcc send $nick " $+ %fserv.temp $+ $2- $+ "
          .timerfstat 0 5 fstatcheck
        }
      }
    }
    elseif ($1 == credit) {
      %i = %fserv.credit. [ $+ [ $nick ] ]
      .msg =$nick you have $bsize(%i) credit
      .msg =$nick -
    }
    elseif ($1 == stat) {
      .msg =$nick %logo fserve stats
      .msg =$nick -
      .msg =$nick %fserv.connects $+ / $+ %fserv.maxconnects connections. $send(0) $+ / $+ %fserv.maxsends sends. $bsize(%fserv.totalsends) sent. %fserv.served served. %fserv.maxcps cps max. min. allowed: %fserv.mincps
      .msg =$nick -
      %i = %fserv.credit. [ $+ [ $nick ] ]
      .msg =$nick you have $bsize(%i) credit
      .msg =$nick -
      %i = $send(0)
      %a = 1
      :rep
      if (%i > 0) && (%a <= %i) {
        set %s $send(%a).path $+ $send(%a).file
        set -u3 %fulldate $asctime($int($calc(($file(%s).size - $send(%a).sent) / $send(%a).cps)))
        %fulldate = $gettok($puttok(%fulldate,$puttok($gettok(%fulldate,4,32),$calc($gettok($gettok(%fulldate,4,32),1,58) + $calc($timezone / 3600)),1,58),4,32),4,32)
        .msg =$nick %a $+ : ( $+ $send(%a).status $+ ) $send(%a) has received $send(%a).pc $+ % ( $+ $bsize($send(%a).sent) $+ ) at $send(%a).cps cps - remaining time: %fulldate
        inc %a 1
        goto rep
      }
      if (%i != 0) .msg =$nick -
    }
    elseif ($1 == quit) || ($1 == bye) || ($1 == exit)  {
      close -c $nick
      .timer 1 2 doclose $nick
    }
    elseif ($1 == help) || ($1 == commands) {
      .msg =$nick file server v1.01 %logo
      .msg =$nick (c) DaftHunk, 1998 - all rights reserved.
      .msg =$nick -
      .msg =$nick available commands: bye, cd, chdir, credit, dir, get, help, ls, quit, rules, stat
      .msg =$nick -
    }
  }
}
#fserv end
