alias mp.stuff {
  set %mp.lof $lof(%mp.act)
  set %mp.name $replace($lower($nopath(%mp.act)),3,,.,.)
  set %mp.act $shortfn(%mp.act)
  set -u3 %mp.secs $mp.time
  set -u3 %mp.time $gettok($asctime(%mp.secs),4,32)
  if ($gettok(%mp.time,1,58) > 1) { %mp.time = $reptok(%mp.time,$gettok(%mp.time,1,58),$calc($gettok(%mp.time,1,58) - 1),1,58) }
  else { %mp.time = $mid(%mp.time,4,5) }    
  set %mp.text ..mp3: $+ %mp.name ( $+ $bsize(%mp.lof) $+ \ $+ %mp.time $+ \ $+ %mp.bit $+ kbps) $chr(35) $+ %mp.actno $+ \ $+ $chr(35) $+ %mp.no
  run $shortfn(%mp.player) $shortfn(%mp.act)
  if (%mp.announce == on) { amsg %mp.text }
  else { 
    if (%mp.chan != $null) msg %mp.chan %mp.text
    if (%mp.chan != $active) echo 14 -at ws %mp.text 
  }
  if (%mp.sound == on) { 
    %i = $chan(0)
    :rep
    if (%i > 0) {
      ctcp $chan(%i) mp3 %mp.name
      dec %i 1
      goto rep
    }
  }
  .timermp3 1 $calc(%mp.secs + 1) mp3
}
alias mp.setplayer set %mp.player $dir="select mp3 player" $mircdir
alias mp.setdir {
  write -c $mircdirdata\mp3list.m3u
  set %mp.dir $sdir="select mp3 directory" $mircdir
  echo 14 -at ws counting mp3 files...
  set %mp.no $findfile(%mp.dir,*.mp3,0)
  echo 14 -at ws found %mp.no mp3s - building playlist...
  %i = 1
  :rep
  if (%i <= %mp.no) {
    write $mircdirdata\mp3list.m3u $findfile(%mp.dir,*.mp3,%i)
    inc %i 1
    goto rep
  }
  set %mp.pl $mircdirdata\mp3list.m3u
  echo 14 -at ws finished compiling playlist.
}
alias mp.setup mp.setplayer | mp.setdir
on 1:load:mp.setup
alias mp3 {
  if (%mp.player == $null) mp.setplayer
  if (%mp.dir == $null) mp.setup
  if ($1 == $null) {
    if ($timer(mp3) == $null) echo 14 -at ws mp3 player for the %logo script v1.2 (c) DaftHunk, 1999
    if ($window(@mp3.control) != $null) {
      drawpic @mp3.control 48 5 $mircdirgfx\mpstopoff.bmp  
      drawpic @mp3.control 25 5 $mircdirgfx\mpplayon.bmp  
    }
    if (%mp.random == on) { 
      set %mp.actno $rand(1,%mp.no)
      set %mp.act $read -l $+ %mp.actno $mircdirdata\mp3list.m3u 
    }
    else {
      inc %mp.actno 1
      if (%mp.actno <= %mp.no) { set %mp.act $read -l $+ %mp.actno $mircdirdata\mp3list.m3u }
      elseif (%mp.loop == on) {
        set %mp.actno 1
        set %mp.act $read -l $+ %mp.actno $mircdirdata\mp3list.m3u
      }
      else { echo 14 -at ws end of playlist | halt }
    }
    mp.stuff
  }
  elseif ($1 == list) {
    window -c @mp3.list
    window -kl @mp3.list
    %i = 1
    :rep
    if (%i <= %mp.no) {
      set -u1 %mpt.f $read -l $+ %i $mircdirdata\mp3list.m3u
      if ($calc(%i % 2) == 0) { aline 14 @mp3.list %i - $right(%mpt.f,$calc($mid(%mpt.f,$len(%mp.dir),0)-1)) }
      else { aline @mp3.list %i - $right(%mpt.f,$calc($mid(%mpt.f,$len(%mp.dir),0)-1)) }
      inc %i 1
      goto rep
    }
    set %mp.no $calc(%i - 1)
  }
  elseif ($1 == random) {
    set %mp.random $iif(%mp.random == on,off,on)
    if (%mp.random == on) { echo 14 -at ws now playing random mp3s } | else { echo 14 -at ws now playing continuously }
  }
  elseif ($1 == stop) {
    if ($timer(mp3) != $null) {
      echo 14 -at ws mp3 player off.
      .timermp3 off
    }
    else echo 14 -at ws mp3 player is not on
  }
  elseif ($1 isnum) {
    if ($1 > 0) && ($1 <= %mp.no) {
      set %mp.actno $1
      set %mp.act $read -l $+ %mp.actno $mircdirdata\mp3list.m3u
      mp.stuff
    }
  }
  elseif ($1 == chan) { if (%mp.announce == on) { echo 14 -at ws you are already announcing to all channels | halt } | set %mp.chan # | echo 14 -at ws now announcing to %mp.chan }
  elseif ($1 == clear) { echo 14 -at ws no longer announcing to %mp.chan | unset %mp.chan }
  elseif ($1 == index) { mp.setdir }
  elseif ($1 == announce) { set %mp.announce $iif(%mp.announce == on,off,on) | echo 14 -at ws mp3 announcements now %mp.announce }
  elseif ($1 == sound) { set %mp.sound $iif(%mp.sound == on,off,on) | echo 14 -at ws mp3 ctcp mp3 announcements now %mp.sound }
  elseif ($1 == prev) {
    if (%mp.actno == 1) { set %mp.actno %mp.no }
    else { dec %mp.actno 1 }
    set %mp.act $read -l $+ %mp.actno %mp.pl
    mp.stuff
  } 
  elseif ($1 == next) {
    if (%mp.actno == %mp.no) { set %mp.actno %mp.no }
    else { inc %mp.actno 1 }
    set %mp.act $read -l $+ %mp.actno %mp.pl
    mp.stuff
  } 
  elseif ($1 == gui) { mp.gui }
  elseif ($1 == repeat) {
    set %mp.loop $iif(%mp.loop == on,off,on)
    echo 14 -at ws repeat now %mp.loop
  }
  elseif ($1 == slist) { 
    set -u1 %tt %mp.dir $+ *.m3u
    set -u1 %t $dir="select playlist" %tt
    if (%t != $null) {
      unset %mp.dir
      set %mp.pl %t
      set %mp.no $lines(%mp.pl)
      set %mp.dir $read -l1 %mp.pl
      set %mp.dir $left(%mp.dir,3)
      echo 14 -at ws loaded %mp.pl with %mp.no mp3s...
      if ($window(@mp3.list) != $null) mp3 list
    }
  }
  else {
    echo 14 -at ws mp3 player for the %logo script v1.2 (c) DaftHunk, 1999
    echo 14 -at ws -
    echo 14 -at ws usage: /mp3 $chr(91) list $chr(124) <num> $chr(124) stop $chr(124) help $chr(124) chan $chr(124) clear $chr(124) random $chr(124) slist $chr(124) announce $chr(124) gui $chr(124) repeat $chr(93)
    echo 14 -at ws list shows the list, <num> plays the number, stop stops playing, help shows this
    echo 14 -at ws chan sets channel announcements for the active channel, clear clears single channel 
    echo 14 -at ws announcements, announce toggles globla announcements, sound toggles ctcp channel
    echo 14 -at ws mp3, random toggles random playing, no parameters starts playing (or plays next)
    echo 14 -at ws repeat toggles repeat, gui toggles graphic user inerface
  }
}
alias mp.time {
  set -u1 %mpt.br $mp.rate(%mp.act) $+ 000
  return $int($calc((%mp.lof * 8) / %mpt.br))
}
alias mp.rate {
  set %mp.bit $read -l1 %mp.act
  if (riff isin %mp.bit) {
    bread %mp.act 74 2 &mp
    set -u1 %mp.bit $calc($bvar(&mp,1) - 16) 
  }
  else {
    if (%mp.bit == $null) { set -u1 %mp.bit $read -l2 $1- }
    set -u1 %mp.bit $calc($asc($mid(%mp.bit,3,1)) - 16)
  }
  return %mp.bit
}
menu @mp3.list {
  dclick:{
    set -u1 %s $gettok($line(@mp3.list,$1),1,32)
    if (%s isnum) && (%s > 0) && (%s <= %mp.no) mp3 %s
  }
  play mp3:{
    set -u1 %s $gettok($sline(@mp3.list,1),1,32)
    if (%s isnum) && (%s > 0) && (%s <= %mp.no) mp3 %s
  }
  next:mp3 next
  previous:mp3 prev
  -
  repeat:mp3 repeat
  shuffle:mp3 random
  -
  search:{
    set -u2 %for $$?="search for what?"
    %for = * $+ %for $+ *
    sline @mp3.list $fline(@mp3.list,%for,1,0)
  }
  -
  remove from list:{
    %i = $sline(@mp3.list,0)
    :rep
    if (%i > 0) {
      set -u1 %mpt.n $gettok($sline(@mp3.list,%i),1,32)
      if (%mpt.n isnum) && (%mpt.n > 0) && (%mpt.n <= %mp.no) {
        write -dl $+ %mpt.n $mircdirdata\mp3list.m3u
        dec %mp.no 1
        dec %i 1
        goto rep
      }
    }
    mp3 list
  }
}
menu @mp3.control {
  sclick:{
    if ($inrect($mouse.x,$mouse.y,3,5,22,15) == $true) { mp3 prev }
    elseif ($inrect($mouse.x,$mouse.y,25,5,22,15) == $true) { 
      if ($timer(mp3) == $null) { 
        drawpic @mp3.control 25 5 $mircdirgfx\mpplayon.bmp 
        drawpic @mp3.control 48 5 $mircdirgfx\mpstopoff.bmp 
        mp3
      }
      else { mp3 %mp.actno }
    }
    elseif ($inrect($mouse.x,$mouse.y,48,5,22,15) == $true) { 
      drawpic @mp3.control 25 5 $mircdirgfx\mpplayoff.bmp 
      drawpic @mp3.control 48 5 $mircdirgfx\mpstopon.bmp 
      mp3 stop
    }
    elseif ($inrect($mouse.x,$mouse.y,70,5,22,15) == $true) { mp3 next }
    elseif ($inrect($mouse.x,$mouse.y,98,5,22,15) == $true) { 
      if ($window(@mp3.list) == $null) {
        drawpic @mp3.control 98 6 $mircdirgfx\plon.bmp
        mp3 list
      }
      else {
        drawpic @mp3.control 98 6 $mircdirgfx\ploff.bmp
        window -c @mp3.list
      }
    }
    elseif ($inrect($mouse.x,$mouse.y,127,5,45,15) == $true) {
      if (%mp.random == on) drawpic @mp3.control 127 6 $mircdirgfx\mpshufoff.bmp
      else drawpic @mp3.control 127 6 $mircdirgfx\mpshufon.bmp
      mp3 random   
    }
    elseif ($inrect($mouse.x,$mouse.y,173,5,28,15) == $true) {
      if (%mp.loop != on) drawpic @mp3.control 173 6 $mircdirgfx\mprepon.bmp
      else drawpic @mp3.control 173 6 $mircdirgfx\mprepoff.bmp
      mp3 repeat
    }
  }
}
alias mp.gui {
  if ($window(@mp3.control) == $null) { 
    window -dhkpo @mp3.control %mp.x %mp.y 210 67
    drawpic @mp3.control 0 0 $mircdirgfx\mpmain.bmp
    if ($timer(mp3) != $null) {
      drawpic @mp3.control 25 5 $mircdirgfx\mpplayon.bmp 
      drawpic @mp3.control 48 5 $mircdirgfx\mpstopoff.bmp 
    }
    else {
      drawpic @mp3.control 25 5 $mircdirgfx\mpplayoff.bmp 
      drawpic @mp3.control 48 5 $mircdirgfx\mpstopon.bmp 
    }
    if ($window(@mp3.list) != $null) { drawpic @mp3.control 98 6 $mircdirgfx\plon.bmp }
    else { drawpic @mp3.control 98 6 $mircdirgfx\ploff.bmp }
    if (%mp.random != on) drawpic @mp3.control 127 6 $mircdirgfx\mpshufoff.bmp
    else drawpic @mp3.control 127 6 $mircdirgfx\mpshufon.bmp
    if (%mp.loop == on) drawpic @mp3.control 173 6 $mircdirgfx\mprepon.bmp
    else drawpic @mp3.control 173 6 $mircdirgfx\mprepoff.bmp
  }
  else window -c @mp3.control
}
